diff --git a/boot/menhir/parser.ml b/boot/menhir/parser.ml
index 6b6fc22..dce95f7 100644
--- a/boot/menhir/parser.ml
+++ b/boot/menhir/parser.ml
@@ -19888,38 +19929,38 @@ module Tables = struct
         let _v : ((Asttypes.label Asttypes.loc * Asttypes.private_flag *
    Parsetree.class_field_kind) *
   Parsetree.attributes) = let _7 = 
-# 2416 "parsing/parser.mly"
+# 2436 "parsing/parser.mly"
     ( xs )
-# 19894 "parsing/parser.ml"
+# 19935 "parsing/parser.ml"
          in
         let _startpos__7_ = _startpos_xs_ in
         let _4 =
           let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
           let _1 = 
-# 3409 "parsing/parser.mly"
+# 3429 "parsing/parser.mly"
                                                 ( _1 )
-# 19902 "parsing/parser.ml"
+# 19943 "parsing/parser.ml"
            in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 19910 "parsing/parser.ml"
+# 19951 "parsing/parser.ml"
           
         in
         let _startpos__4_ = _startpos__1_inlined1_ in
         let _2 = 
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 19917 "parsing/parser.ml"
+# 19958 "parsing/parser.ml"
          in
         let (_endpos__2_, _startpos__2_) = (_endpos__1_, _startpos__1_) in
         let _1 = 
-# 3649 "parsing/parser.mly"
+# 3677 "parsing/parser.mly"
                                                 ( Fresh )
-# 19923 "parsing/parser.ml"
+# 19964 "parsing/parser.ml"
          in
         let (_endpos__1_, _startpos__1_) = (_endpos__0_, _endpos__0_) in
         let _endpos = _endpos__11_ in
@@ -19935,7 +19976,7 @@ module Tables = struct
               _startpos__4_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1889 "parsing/parser.mly"
+# 1897 "parsing/parser.mly"
       ( let poly_exp_loc = (_startpos__7_, _endpos__11_) in
         let poly_exp =
           let exp, poly =
@@ -19946,7 +19987,7 @@ module Tables = struct
           ghexp ~loc:poly_exp_loc (Pexp_poly(exp, Some poly)) in
         (_4, _3,
         Cfk_concrete (_1, poly_exp)), _2 )
-# 19950 "parsing/parser.ml"
+# 19991 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20032,9 +20073,9 @@ module Tables = struct
         let _6 : unit = Obj.magic _6 in
         let _5 : unit = Obj.magic _5 in
         let _1_inlined2 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 20038 "parsing/parser.ml"
+# 20079 "parsing/parser.ml"
         ) = Obj.magic _1_inlined2 in
         let _3 : (Asttypes.private_flag) = Obj.magic _3 in
         let _1_inlined1 : (Parsetree.attributes) = Obj.magic _1_inlined1 in
@@ -20045,41 +20086,41 @@ module Tables = struct
         let _v : ((Asttypes.label Asttypes.loc * Asttypes.private_flag *
    Parsetree.class_field_kind) *
   Parsetree.attributes) = let _7 = 
-# 2416 "parsing/parser.mly"
+# 2436 "parsing/parser.mly"
     ( xs )
-# 20051 "parsing/parser.ml"
+# 20092 "parsing/parser.ml"
          in
         let _startpos__7_ = _startpos_xs_ in
         let _4 =
           let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined2_, _startpos__1_inlined2_, _1_inlined2) in
           let _1 = 
-# 3409 "parsing/parser.mly"
+# 3429 "parsing/parser.mly"
                                                 ( _1 )
-# 20059 "parsing/parser.ml"
+# 20100 "parsing/parser.ml"
            in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 20067 "parsing/parser.ml"
+# 20108 "parsing/parser.ml"
           
         in
         let _startpos__4_ = _startpos__1_inlined2_ in
         let _2 =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 20076 "parsing/parser.ml"
+# 20117 "parsing/parser.ml"
           
         in
         let (_endpos__2_, _startpos__2_) = (_endpos__1_inlined1_, _startpos__1_inlined1_) in
         let _1 = 
-# 3650 "parsing/parser.mly"
+# 3678 "parsing/parser.mly"
                                                 ( Override )
-# 20083 "parsing/parser.ml"
+# 20124 "parsing/parser.ml"
          in
         let _endpos = _endpos__11_ in
         let _symbolstartpos = if _startpos__1_ != _endpos__1_ then
@@ -20094,7 +20135,7 @@ module Tables = struct
               _startpos__4_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1889 "parsing/parser.mly"
+# 1897 "parsing/parser.mly"
       ( let poly_exp_loc = (_startpos__7_, _endpos__11_) in
         let poly_exp =
           let exp, poly =
@@ -20105,7 +20146,7 @@ module Tables = struct
           ghexp ~loc:poly_exp_loc (Pexp_poly(exp, Some poly)) in
         (_4, _3,
         Cfk_concrete (_1, poly_exp)), _2 )
-# 20109 "parsing/parser.ml"
+# 20150 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20124,17 +20165,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 20130 "parsing/parser.ml"
+# 20171 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20138 "parsing/parser.ml"
+# 20179 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20165,9 +20206,9 @@ module Tables = struct
           };
         } = _menhir_stack in
         let _3 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 20171 "parsing/parser.ml"
+# 20212 "parsing/parser.ml"
         ) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (Longident.t) = Obj.magic _1 in
@@ -20175,9 +20216,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = 
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20181 "parsing/parser.ml"
+# 20222 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20196,17 +20237,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 701 "parsing/parser.mly"
+# 709 "parsing/parser.mly"
        (string)
-# 20202 "parsing/parser.ml"
+# 20243 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20210 "parsing/parser.ml"
+# 20251 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20237,9 +20278,9 @@ module Tables = struct
           };
         } = _menhir_stack in
         let _3 : (
-# 701 "parsing/parser.mly"
+# 709 "parsing/parser.mly"
        (string)
-# 20243 "parsing/parser.ml"
+# 20284 "parsing/parser.ml"
         ) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (Longident.t) = Obj.magic _1 in
@@ -20247,9 +20288,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = 
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20253 "parsing/parser.ml"
+# 20294 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20272,14 +20313,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = let _1 = 
-# 3543 "parsing/parser.mly"
+# 3571 "parsing/parser.mly"
                                                   ( _1 )
-# 20278 "parsing/parser.ml"
+# 20319 "parsing/parser.ml"
          in
         
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20283 "parsing/parser.ml"
+# 20324 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20317,20 +20358,20 @@ module Tables = struct
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = let _1 =
           let _1 = 
-# 3486 "parsing/parser.mly"
+# 3514 "parsing/parser.mly"
                                                 ( "::" )
-# 20323 "parsing/parser.ml"
+# 20364 "parsing/parser.ml"
            in
           
-# 3543 "parsing/parser.mly"
+# 3571 "parsing/parser.mly"
                                                   ( _1 )
-# 20328 "parsing/parser.ml"
+# 20369 "parsing/parser.ml"
           
         in
         
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20334 "parsing/parser.ml"
+# 20375 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20353,14 +20394,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = let _1 = 
-# 3543 "parsing/parser.mly"
+# 3571 "parsing/parser.mly"
                                                   ( _1 )
-# 20359 "parsing/parser.ml"
+# 20400 "parsing/parser.ml"
          in
         
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20364 "parsing/parser.ml"
+# 20405 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20399,15 +20440,15 @@ module Tables = struct
         let _v : (Longident.t) = let _3 =
           let _1 = _1_inlined1 in
           
-# 3543 "parsing/parser.mly"
+# 3571 "parsing/parser.mly"
                                                   ( _1 )
-# 20405 "parsing/parser.ml"
+# 20446 "parsing/parser.ml"
           
         in
         
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20411 "parsing/parser.ml"
+# 20452 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20460,20 +20501,20 @@ module Tables = struct
         let _v : (Longident.t) = let _3 =
           let (_2, _1) = (_2_inlined1, _1_inlined1) in
           let _1 = 
-# 3486 "parsing/parser.mly"
+# 3514 "parsing/parser.mly"
                                                 ( "::" )
-# 20466 "parsing/parser.ml"
+# 20507 "parsing/parser.ml"
            in
           
-# 3543 "parsing/parser.mly"
+# 3571 "parsing/parser.mly"
                                                   ( _1 )
-# 20471 "parsing/parser.ml"
+# 20512 "parsing/parser.ml"
           
         in
         
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20477 "parsing/parser.ml"
+# 20518 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20512,15 +20553,15 @@ module Tables = struct
         let _v : (Longident.t) = let _3 =
           let _1 = _1_inlined1 in
           
-# 3543 "parsing/parser.mly"
+# 3571 "parsing/parser.mly"
                                                   ( _1 )
-# 20518 "parsing/parser.ml"
+# 20559 "parsing/parser.ml"
           
         in
         
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20524 "parsing/parser.ml"
+# 20565 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20543,9 +20584,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20549 "parsing/parser.ml"
+# 20590 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20582,9 +20623,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = 
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20588 "parsing/parser.ml"
+# 20629 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20603,17 +20644,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 20609 "parsing/parser.ml"
+# 20650 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20617 "parsing/parser.ml"
+# 20658 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20644,9 +20685,9 @@ module Tables = struct
           };
         } = _menhir_stack in
         let _3 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 20650 "parsing/parser.ml"
+# 20691 "parsing/parser.ml"
         ) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (Longident.t) = Obj.magic _1 in
@@ -20654,9 +20695,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = 
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20660 "parsing/parser.ml"
+# 20701 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20675,17 +20716,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 701 "parsing/parser.mly"
+# 709 "parsing/parser.mly"
        (string)
-# 20681 "parsing/parser.ml"
+# 20722 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20689 "parsing/parser.ml"
+# 20730 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20716,9 +20757,9 @@ module Tables = struct
           };
         } = _menhir_stack in
         let _3 : (
-# 701 "parsing/parser.mly"
+# 709 "parsing/parser.mly"
        (string)
-# 20722 "parsing/parser.ml"
+# 20763 "parsing/parser.ml"
         ) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (Longident.t) = Obj.magic _1 in
@@ -20726,9 +20767,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = 
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20732 "parsing/parser.ml"
+# 20773 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20751,9 +20792,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3506 "parsing/parser.mly"
+# 3534 "parsing/parser.mly"
                       ( Lident _1 )
-# 20757 "parsing/parser.ml"
+# 20798 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20790,9 +20831,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = 
-# 3507 "parsing/parser.mly"
+# 3535 "parsing/parser.mly"
                       ( Ldot(_1,_3) )
-# 20796 "parsing/parser.ml"
+# 20837 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20815,9 +20856,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3522 "parsing/parser.mly"
+# 3550 "parsing/parser.mly"
                                             ( _1 )
-# 20821 "parsing/parser.ml"
+# 20862 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20864,9 +20905,9 @@ module Tables = struct
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 3524 "parsing/parser.mly"
+# 3552 "parsing/parser.mly"
       ( lapply ~loc:_sloc _1 _3 )
-# 20870 "parsing/parser.ml"
+# 20911 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20904,9 +20945,9 @@ module Tables = struct
         let _endpos = _endpos__3_ in
         let _v : (Longident.t) = let _loc__3_ = (_startpos__3_, _endpos__3_) in
         
-# 3526 "parsing/parser.mly"
+# 3554 "parsing/parser.mly"
       ( expecting _loc__3_ "module path" )
-# 20910 "parsing/parser.ml"
+# 20951 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20929,9 +20970,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Longident.t) = 
-# 3519 "parsing/parser.mly"
+# 3547 "parsing/parser.mly"
                                          ( _1 )
-# 20935 "parsing/parser.ml"
+# 20976 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -20961,9 +21002,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos_me_ in
         let _v : (Parsetree.module_expr) = 
-# 1377 "parsing/parser.mly"
+# 1385 "parsing/parser.mly"
       ( me )
-# 20967 "parsing/parser.ml"
+# 21008 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21008,24 +21049,24 @@ module Tables = struct
         let _endpos = _endpos_me_ in
         let _v : (Parsetree.module_expr) = let _1 =
           let _1 = 
-# 1380 "parsing/parser.mly"
+# 1388 "parsing/parser.mly"
         ( Pmod_constraint(me, mty) )
-# 21014 "parsing/parser.ml"
+# 21055 "parsing/parser.ml"
            in
           let _endpos__1_ = _endpos_me_ in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 860 "parsing/parser.mly"
+# 868 "parsing/parser.mly"
     ( mkmod ~loc:_sloc _1 )
-# 21023 "parsing/parser.ml"
+# 21064 "parsing/parser.ml"
           
         in
         
-# 1384 "parsing/parser.mly"
+# 1392 "parsing/parser.mly"
     ( _1 )
-# 21029 "parsing/parser.ml"
+# 21070 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21056,25 +21097,25 @@ module Tables = struct
         let _endpos = _endpos_body_ in
         let _v : (Parsetree.module_expr) = let _1 =
           let _1 = 
-# 1382 "parsing/parser.mly"
+# 1390 "parsing/parser.mly"
         ( let (_, arg) = arg_and_pos in
           Pmod_functor(arg, body) )
-# 21063 "parsing/parser.ml"
+# 21104 "parsing/parser.ml"
            in
           let (_endpos__1_, _startpos__1_) = (_endpos_body_, _startpos_arg_and_pos_) in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 860 "parsing/parser.mly"
+# 868 "parsing/parser.mly"
     ( mkmod ~loc:_sloc _1 )
-# 21072 "parsing/parser.ml"
+# 21113 "parsing/parser.ml"
           
         in
         
-# 1384 "parsing/parser.mly"
+# 1392 "parsing/parser.mly"
     ( _1 )
-# 21078 "parsing/parser.ml"
+# 21119 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21104,9 +21145,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos_mty_ in
         let _v : (Parsetree.module_type) = 
-# 1621 "parsing/parser.mly"
+# 1629 "parsing/parser.mly"
       ( mty )
-# 21110 "parsing/parser.ml"
+# 21151 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21137,25 +21178,25 @@ module Tables = struct
         let _endpos = _endpos_body_ in
         let _v : (Parsetree.module_type) = let _1 =
           let _1 = 
-# 1624 "parsing/parser.mly"
+# 1632 "parsing/parser.mly"
         ( let (_, arg) = arg_and_pos in
           Pmty_functor(arg, body) )
-# 21144 "parsing/parser.ml"
+# 21185 "parsing/parser.ml"
            in
           let (_endpos__1_, _startpos__1_) = (_endpos_body_, _startpos_arg_and_pos_) in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 862 "parsing/parser.mly"
+# 870 "parsing/parser.mly"
     ( mkmty ~loc:_sloc _1 )
-# 21153 "parsing/parser.ml"
+# 21194 "parsing/parser.ml"
           
         in
         
-# 1627 "parsing/parser.mly"
+# 1635 "parsing/parser.mly"
     ( _1 )
-# 21159 "parsing/parser.ml"
+# 21200 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21201,18 +21242,18 @@ module Tables = struct
         let _v : (Parsetree.module_expr) = let attrs =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 21207 "parsing/parser.ml"
+# 21248 "parsing/parser.ml"
           
         in
         let _endpos = _endpos__4_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1216 "parsing/parser.mly"
+# 1224 "parsing/parser.mly"
       ( mkmod ~loc:_sloc ~attrs (Pmod_structure s) )
-# 21216 "parsing/parser.ml"
+# 21257 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21258,17 +21299,17 @@ module Tables = struct
         let _v : (Parsetree.module_expr) = let _2 =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 21264 "parsing/parser.ml"
+# 21305 "parsing/parser.ml"
           
         in
         let _loc__4_ = (_startpos__4_, _endpos__4_) in
         let _loc__1_ = (_startpos__1_, _endpos__1_) in
         
-# 1218 "parsing/parser.mly"
+# 1226 "parsing/parser.mly"
       ( unclosed "struct" _loc__1_ "end" _loc__4_ )
-# 21272 "parsing/parser.ml"
+# 21313 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21321,30 +21362,30 @@ module Tables = struct
         let _v : (Parsetree.module_expr) = let args =
           let _1 = _1_inlined2 in
           
-# 1182 "parsing/parser.mly"
+# 1190 "parsing/parser.mly"
     ( _1 )
-# 21327 "parsing/parser.ml"
+# 21368 "parsing/parser.ml"
           
         in
         let attrs =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 21335 "parsing/parser.ml"
+# 21376 "parsing/parser.ml"
           
         in
         let _endpos = _endpos_me_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1220 "parsing/parser.mly"
+# 1228 "parsing/parser.mly"
       ( wrap_mod_attrs ~loc:_sloc attrs (
           List.fold_left (fun acc (startpos, arg) ->
             mkmod ~loc:(startpos, _endpos) (Pmod_functor (arg, acc))
           ) me args
         ) )
-# 21348 "parsing/parser.ml"
+# 21389 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21367,9 +21408,9 @@ module Tables = struct
         let _startpos = _startpos_me_ in
         let _endpos = _endpos_me_ in
         let _v : (Parsetree.module_expr) = 
-# 1226 "parsing/parser.mly"
+# 1234 "parsing/parser.mly"
       ( me )
-# 21373 "parsing/parser.ml"
+# 21414 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21399,9 +21440,9 @@ module Tables = struct
         let _startpos = _startpos_me_ in
         let _endpos = _endpos_attr_ in
         let _v : (Parsetree.module_expr) = 
-# 1228 "parsing/parser.mly"
+# 1236 "parsing/parser.mly"
       ( Mod.attr me attr )
-# 21405 "parsing/parser.ml"
+# 21446 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21430,30 +21471,30 @@ module Tables = struct
               let _symbolstartpos = _startpos__1_ in
               let _sloc = (_symbolstartpos, _endpos) in
               
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 21436 "parsing/parser.ml"
+# 21477 "parsing/parser.ml"
               
             in
             
-# 1232 "parsing/parser.mly"
+# 1240 "parsing/parser.mly"
         ( Pmod_ident x )
-# 21442 "parsing/parser.ml"
+# 21483 "parsing/parser.ml"
             
           in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 860 "parsing/parser.mly"
+# 868 "parsing/parser.mly"
     ( mkmod ~loc:_sloc _1 )
-# 21451 "parsing/parser.ml"
+# 21492 "parsing/parser.ml"
           
         in
         
-# 1244 "parsing/parser.mly"
+# 1252 "parsing/parser.mly"
     ( _1 )
-# 21457 "parsing/parser.ml"
+# 21498 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21484,24 +21525,24 @@ module Tables = struct
         let _endpos = _endpos_me2_ in
         let _v : (Parsetree.module_expr) = let _1 =
           let _1 = 
-# 1235 "parsing/parser.mly"
+# 1243 "parsing/parser.mly"
         ( Pmod_apply(me1, me2) )
-# 21490 "parsing/parser.ml"
+# 21531 "parsing/parser.ml"
            in
           let (_endpos__1_, _startpos__1_) = (_endpos_me2_, _startpos_me1_) in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 860 "parsing/parser.mly"
+# 868 "parsing/parser.mly"
     ( mkmod ~loc:_sloc _1 )
-# 21499 "parsing/parser.ml"
+# 21540 "parsing/parser.ml"
           
         in
         
-# 1244 "parsing/parser.mly"
+# 1252 "parsing/parser.mly"
     ( _1 )
-# 21505 "parsing/parser.ml"
+# 21546 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21543,10 +21584,10 @@ module Tables = struct
             let _symbolstartpos = _startpos_me1_ in
             let _sloc = (_symbolstartpos, _endpos) in
             
-# 1238 "parsing/parser.mly"
+# 1246 "parsing/parser.mly"
         ( (* TODO review mkmod location *)
           Pmod_apply(me1, mkmod ~loc:_sloc (Pmod_structure [])) )
-# 21550 "parsing/parser.ml"
+# 21591 "parsing/parser.ml"
             
           in
           let (_endpos__1_, _startpos__1_) = (_endpos__3_, _startpos_me1_) in
@@ -21554,15 +21595,15 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 860 "parsing/parser.mly"
+# 868 "parsing/parser.mly"
     ( mkmod ~loc:_sloc _1 )
-# 21560 "parsing/parser.ml"
+# 21601 "parsing/parser.ml"
           
         in
         
-# 1244 "parsing/parser.mly"
+# 1252 "parsing/parser.mly"
     ( _1 )
-# 21566 "parsing/parser.ml"
+# 21607 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21586,24 +21627,24 @@ module Tables = struct
         let _endpos = _endpos_ex_ in
         let _v : (Parsetree.module_expr) = let _1 =
           let _1 = 
-# 1242 "parsing/parser.mly"
+# 1250 "parsing/parser.mly"
         ( Pmod_extension ex )
-# 21592 "parsing/parser.ml"
+# 21633 "parsing/parser.ml"
            in
           let (_endpos__1_, _startpos__1_) = (_endpos_ex_, _startpos_ex_) in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 860 "parsing/parser.mly"
+# 868 "parsing/parser.mly"
     ( mkmod ~loc:_sloc _1 )
-# 21601 "parsing/parser.ml"
+# 21642 "parsing/parser.ml"
           
         in
         
-# 1244 "parsing/parser.mly"
+# 1252 "parsing/parser.mly"
     ( _1 )
-# 21607 "parsing/parser.ml"
+# 21648 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21622,17 +21663,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let x : (
-# 701 "parsing/parser.mly"
+# 709 "parsing/parser.mly"
        (string)
-# 21628 "parsing/parser.ml"
+# 21669 "parsing/parser.ml"
         ) = Obj.magic x in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos_x_ in
         let _endpos = _endpos_x_ in
         let _v : (string option) = 
-# 1199 "parsing/parser.mly"
+# 1207 "parsing/parser.mly"
       ( Some x )
-# 21636 "parsing/parser.ml"
+# 21677 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21655,9 +21696,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (string option) = 
-# 1202 "parsing/parser.mly"
+# 1210 "parsing/parser.mly"
       ( None )
-# 21661 "parsing/parser.ml"
+# 21702 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -21715,9 +21756,9 @@ module Tables = struct
         let _1_inlined3 : (Longident.t) = Obj.magic _1_inlined3 in
         let _5 : unit = Obj.magic _5 in
         let _1_inlined2 : (
-# 701 "parsing/parser.mly"
+# 709 "parsing/parser.mly"
        (string)
-# 21721 "parsing/parser.ml"
+# 21762 "parsing/parser.ml"
         ) = Obj.magic _1_inlined2 in
         let _1_inlined1 : (Parsetree.attributes) = Obj.magic _1_inlined1 in
         let ext : (string Asttypes.loc option) = Obj.magic ext in
@@ -21728,9 +21769,9 @@ module Tables = struct
         let _v : (Parsetree.module_substitution * string Asttypes.loc option) = let attrs2 =
           let _1 = _1_inlined4 in
           
-# 3743 "parsing/parser.mly"
+# 3771 "parsing/parser.mly"
     ( _1 )
-# 21734 "parsing/parser.ml"
+# 21775 "parsing/parser.ml"
           
         in
         let _endpos_attrs2_ = _endpos__1_inlined4_ in
@@ -21740,9 +21781,9 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 21746 "parsing/parser.ml"
+# 21787 "parsing/parser.ml"
           
         in
         let uid =
